import java.applet.Applet;
import java.awt.Graphics;
import java.awt.Dimension;
import java.awt.Event;
import java.awt.Color;

public class Displayer
	extends Applet
	{
	/*
	An applet that displays strings written into its window
	by other applets.
	*/

	private String name;
	private Dimension size;
	private final static int WINDOW_SIZE = 210; //in pixels
	private final static int OFFSET = 5; //in pixels

	public void init()
		{
		name = this.getParameter("DisplayerName");
		size = this.getSize();
		this.setBackground(Color.white);
		}

	public void paint(Graphics graphics)
		{
		graphics.drawRect(0, 0, size.width - OFFSET, size.height - OFFSET);
		graphics.drawString("Name: " + name, 0, 4 * OFFSET);
		}

	public boolean mouseEnter(Event event, int x, int y)
		{
		/*
		Clean this applet if the user moves over its window.
		*/

		repaint();

		return false;
		}
	}
