
import java.awt.Panel;
import java.awt.Scrollbar;
import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Event;
import SliderApplet;

public class Slider extends Panel
	{
	private Scrollbar scrollbar;
	private int value;
	private SliderApplet creator;

	public Slider(SliderApplet creator)
		{
		super();
		this.setLayout(new BorderLayout());
		this.resize(new Dimension(112, 42));
		scrollbar = new Scrollbar(Scrollbar.HORIZONTAL, 0, 10, 0, 100);
		this.add("Center", scrollbar);
		this.creator = creator;
		}

	public boolean handleEvent(Event event)
		{
		if (event.target == scrollbar)
			{
			creator.setValue(scrollbar.getValue());
			return true;
			}

		return super.handleEvent(event);
		}
	}
